<?php
require_once('phprpc_server.php');

function ReadAlexaRank($link) {
    $fp = fsockopen("xml.alexa.com", 80, $errno, $errstr, 30);
    if (!$fp) {
        echo "$errstr ($errno)\n";
        return false;
    }
    else {
        $out = "GET $link HTTP/1.0\r\n";
        $out .= "Host: xml.alexa.com\r\n";
        $out .= "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322; Alexa Toolbar)\r\n";
        $out .= "If-Modified-Since: Thu, 26 Aug 2002 08:24:16 GMT\r\n";
        $out .= "Connection: Close\r\n\r\n";
        fwrite($fp, $out);
        do { 
            $line = fgets($fp, 128); 
        } while ($line !== "\r\n");
        $data = fread($fp, 8192); 
        fclose($fp);
        return $data;
    }
}

function AlexaRank($url) {
    $uid = date('YmdHis');
    $userip = mt_rand(200, 220) . '.' . mt_rand(1, 240) . '.' . mt_rand(1, 254) . '.' . mt_rand(1, 254);
    $link = "/data?cli=10&dat=nsa&ver=quirk-searchstatus&uid=$uid&userip=$userip&url=" . urlencode($url);
    $data = ReadAlexaRank($link);
    if ($data === false) {
        return -1;
    }
    if (preg_match("/\<POPULARITY URL=\"(.*?)\" TEXT=\"(\d+?)\"/", $data, $match)) {
        return $match[2];
    }
    else {
        return 0;
    }
}

$server = new PHPRPC_Server();
$server->add('alexarank');
$server->start();
?>